//---------------------------------------------------------------------------

#include <vcl.h>
#include <typinfo.hpp>
#include <Registry.hpp>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
PPropInfo PropInfo;
TTypeKinds typekind;
TComponent *pComponent;
TControl *pControl;
String RKey;
Longint OW,OH,OP;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  bool B;
  HKEY CurrentKey;
  TRegistry *Reg;
  String R1,R2;
  // xs  Form width , height , PixelsPerInch
  OW = Form1->Width;
  OH = Form1->Height;
  OP = Form1->PixelsPerInch;
  RKey = "\FormAutoSize";
  Reg = new TRegistry(); //Reg := TRegistry.Create;  //-----Crano-----
 try
 {
    Reg->RootKey = HKEY_CURRENT_USER;
    if (Reg->KeyExists(RKey))
      Reg->DeleteKey(RKey);
    Reg->CreateKey(RKey);
    // xsӤW
    for (int i=0;i<Form1->ComponentCount ;i++) {
      pComponent=Form1->Components[i];
      pControl=(TControl *)pComponent;
      if (dynamic_cast<TControl *>(pComponent) == NULL)
        continue;
      Reg->OpenKey(RKey,false);
      R1=pComponent->Name;
      if(!Reg->KeyExists(RKey+"\\"+R1))  // if not Reg.KeyExists(RKey+'\'+R1) then
        Reg->CreateKey(R1);
      Reg->OpenKey(R1,true);
      Reg->WriteInteger("Top",pControl->Top);
      Reg->WriteInteger("Left",pControl->Left);
      Reg->WriteInteger("Width",pControl->Width);
      Reg->WriteInteger("Height",pControl->Height);
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "Font");
      if (PropInfo ) {
        Reg->WriteInteger("FontSize",TEdit(pComponent).Font->Size);
        Reg->WriteInteger("FontHeight",TEdit(pComponent).Font->Height);
      }
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "Panels");
      if (PropInfo ) { // && TStatusBar(pComponent).Panels->Count > 0)         {
        TStatusBar *pStatusBar;
        pStatusBar=(TStatusBar *)pComponent;
        int i1=pStatusBar->Panels->Count;
        if (i1>0) {
          if (!Reg->KeyExists("Panels"))
            Reg->CreateKey("Panels");
          Reg->OpenKey("Panels",true);
          for (int J = 0 ; J<i1;J++)  {
            Reg->WriteInteger(IntToStr(J),pStatusBar->Panels->Items[J]->Width);
          }
        }
      }
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "Columns");
      if (PropInfo ) {
        TDBGrid *pDBGrid;
        pDBGrid=(TDBGrid *)pComponent;
        int i1=pDBGrid->Columns->Count;
        if (i1>0) {
          if (!Reg->KeyExists("Columns"))
            Reg->CreateKey("Columns");
          Reg->OpenKey("Columns",true);
          for (int J = 0; J< i1 ; J++)
          {
             Reg->WriteInteger("Width"+IntToStr(J),pDBGrid->Columns->Items[J]->Width);
             Reg->WriteInteger("FontSize"+IntToStr(J),pDBGrid->Columns->Items[J]->Font->Size);
             Reg->WriteInteger("FontHeight"+IntToStr(J),pDBGrid->Columns->Items[J]->Font->Height);
             Reg->WriteInteger("TitleFontSize"+IntToStr(J),pDBGrid->Columns->Items[J]->Title->Font->Size);
             Reg->WriteInteger("TitleFontHeight"+IntToStr(J),pDBGrid->Columns->Items[J]->Title->Font->Height);
          }
        }
      }
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "DefaultColWidth");
      if (PropInfo)
        Reg->WriteInteger("DefaultColWidth",TStringGrid(pComponent).DefaultColWidth);
      // Have DefaultRowHeight
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "DefaultRowHeight");
      if (PropInfo)
        Reg->WriteInteger("DefaultRowHeight",TStringGrid(pComponent).DefaultRowHeight);
      Reg->CloseKey();
    }
 }
 catch(...)
 {
   Reg->Free();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  TRegistry *Reg;
  int I,J ;
  Longint T,L,W,H,FS,FH;
  Longint NW,NH,NP ;
  String R1;
  NW = Form1->Width;
  NH = Form1->Height;
  NP = Form1->PixelsPerInch;
  Reg = new TRegistry();
try
{
  Reg->RootKey = HKEY_CURRENT_USER;
  Reg->OpenKeyReadOnly(RKey);
  for (int i=0;i<Form1->ComponentCount ;i++) {
    pComponent=Form1->Components[i];
    pControl=(TControl *)pComponent;
    if (dynamic_cast<TControl *>(pComponent) == NULL)
      continue;
    Reg->OpenKey(RKey,false);
    R1=pComponent->Name;
    if (Reg->OpenKey(R1,false)) {
      T = Reg->ReadInteger("Top");
      L = Reg->ReadInteger("Left");
      W = Reg->ReadInteger("Width");
      H = Reg->ReadInteger("Height");
      if (OH != 0)
        pControl->Top = Longint(T*NH/OH) ;
      if (OW != 0)
        pControl->Left = Longint(L*NW/OW);
      if (OW != 0)
        pControl->Width = Longint(W*NW/OW);
      if (OH != 0)
        pControl->Height = Longint(H*NH/OH);
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "Font");
      if (PropInfo ) {
        FH = Reg->ReadInteger("FontHeight");
        TEdit(pComponent).Font->Size = Longint((FS * NP/OP) * NH / OH);
        TEdit(pComponent).Font->Height = Longint((FH * NP/OP) * NH / OH);
      }

      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "Panels");
      if (PropInfo ) { // && TStatusBar(pComponent).Panels->Count > 0)         {
        TStatusBar *pStatusBar;
        pStatusBar=(TStatusBar *)pComponent;
        int i1=pStatusBar->Panels->Count;
        if (i1>0) {
          Reg->OpenKey("Panels",false);
          for (int J = 0 ; J<i1;J++)  {
            W = Reg->ReadInteger(IntToStr(J));
            pStatusBar->Panels->Items[J]->Width= Longint(W * NW / OW);
          }
        }
      }
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "Columns");
      if (PropInfo ) {
        TDBGrid *pDBGrid;
        pDBGrid=(TDBGrid *)pComponent;
        int i1=pDBGrid->Columns->Count;
        if (i1>0) {
          Reg->OpenKey("Columns",false);
          for (int J = 0; J< i1 ; J++)
          {
            W = Reg->ReadInteger("Width"+IntToStr(J));
            pDBGrid->Columns->Items[J]->Width= Longint(W * NW / OW);
            FS = Reg->ReadInteger("FontSize"+IntToStr(J));
//            FH = Reg->ReadInteger("FontHeight"+IntToStr(J));
            // `N  font.size  font.height |ۤv  ҥHܤ@Yi
            pDBGrid->Columns->Items[J]->Font->Size= Longint((FS * NP % OP) * NH % OH);
//            pDBGrid->Columns->Items[J]->Font->Height= Longint((FH * NP % OP) * NH % OH);
            FS = Reg->ReadInteger("TitleFontSize"+IntToStr(J));
//            FH = Reg->ReadInteger("TitleFontHeight"+IntToStr(J));
             pDBGrid->Columns->Items[J]->Title->Font->Size= Longint((FS * NP % OP) * NH % OH);
             pDBGrid->Columns->Items[J]->Title->Font->Height= Longint((FH * NP % OP) * NH % OH);
          }
        }
      }
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "DefaultColWidth");
      if (PropInfo) {
        W = Reg->ReadInteger("DefaultColWidth");
        if (OW != 0 )
          TStringGrid(pComponent).DefaultColWidth  = Longint(W * NW / OW);
      }
      // Have DefaultRowHeight
      PropInfo = GetPropInfo((TTypeInfo *)pComponent->ClassInfo(), "DefaultRowHeight");
      if (PropInfo) {
         H = Reg->ReadInteger("DefaultRowHeight");
         if (OH != 0)
           TStringGrid(pComponent).DefaultRowHeight = Longint(H * NH / OH);
      }

      Reg->CloseKey();
    }
  }
  Reg->CloseKey();
}
catch(...)    {
  Reg->Free();
}
}
//---------------------------------------------------------------------------
